/*-
 * ============LICENSE_START=======================================================
 * ONAP
 * ================================================================================
 * Copyright (C) 2021 AT&T Intellectual Property. All rights reserved.
 * ================================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ============LICENSE_END=========================================================
 */

package org.onap.policy.pap.main.notification;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.Test;

/**
 * Only test the methods that are not generated by lombok.
 */
public class StatusActionTest {

    @Test
    public void testSetChanged() {
        StatusAction status = new StatusAction(StatusAction.Action.UNCHANGED, null);

        // new records should always remain new - action should not change
        status.setAction(StatusAction.Action.CREATED);
        status.setChanged();
        assertThat(status.getAction()).isEqualTo(StatusAction.Action.CREATED);

        // all other actions should change

        status.setAction(StatusAction.Action.UNCHANGED);
        status.setChanged();
        assertThat(status.getAction()).isEqualTo(StatusAction.Action.UPDATED);

        status.setAction(StatusAction.Action.DELETED);
        status.setChanged();
        assertThat(status.getAction()).isEqualTo(StatusAction.Action.UPDATED);

        status.setAction(StatusAction.Action.UPDATED);
        status.setChanged();
        assertThat(status.getAction()).isEqualTo(StatusAction.Action.UPDATED);
    }
}
